/*
 * Copyright (c) 1985 Corporation for Research and Educational Networking
 * Copyright (c) 1988 University of Illinois Board of Trustees, Steven
 *		Dorner, and Paul Pomes
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the Corporation for
 *	Research and Educational Networking (CREN), the University of
 *	Illinois at Urbana, and their contributors.
 * 4. Neither the name of CREN, the University nor the names of their
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE TRUSTEES AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TRUSTEES OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static char  RcsId[] = "@(#)$Id: query.c,v 1.63 1995/06/28 17:40:32 p-pomes Exp $";
#endif

#include "protos.h"
#include "ph2ldap.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/signal.h>
#ifndef RLIM_INFINITY
# define	RLIM_INFINITY	0x7fffffff
#endif

extern int OldPh;		/* language.l */
extern FILE *TempOutput;
extern int InputType;
extern int LocalUser;
extern int OffCampus;


#ifndef CPU_LIMIT
# define CPU_LIMIT 7
#endif
int	IndicateAlways = 0;

/*
* execute a query request
 */



void DoQuery(ARG *argp)
{
	
     int i;  
     char filter[MAX_FILTER];   /* storage to build the ldap filter from ph query*/ 
     char **fields;             /* storage for the return fields of the query results */ 

     /* allocate enough space for most number of fields */
     fields = (char **)malloc(MAX_FIELDS*sizeof(char *));

      /*
       * make the ldap filter from ph query and keep it in filter
       * and keep the fields interested for presentation in fields
       */
      if(! MakeLdapFilter(argp, filter, fields))
      {
         DoReply(LR_ERROR, "Did not understand %s.", argp->aFirst);
         return;
      }
      else
	SearchLdap(filter, fields);  /* all the action is here */


      /* cleanup memory */

      i=0;
      while(fields[i++] != NULL)
         free( fields[i]);

      return;
      
}/* end of query */
